//     TesterCache.

#property script_show_inputs

input string inFileName = "Tester.opt"; // opt-FileName
input int inNum = 0;                    //   

#include <fxsaber\TesterCache\TesterCache.mqh> // / opt-   MT5-.

//      .
template <typename T>
int GetMaxProfitPos( const TESTERCACHE<T> &Cache )
{
  int Pos = 0;
  double MaxProfit = -DBL_MAX;

  for (int i = Cache.GetAmount() - 1; i >= 0; i--)
    if (Cache[i].TesterStatistics(STAT_PROFIT) > MaxProfit)
    {
      MaxProfit = Cache[i].TesterStatistics(STAT_PROFIT);

      Pos = i;
    }

  return(Pos);
}

void OnStart()
{
//  TESTERCACHE<MATHEMATICS> Cache;             //   . 
//  TESTERCACHE<TestCacheSymbolRecord> Cache;   //   
  TESTERCACHE<ExpTradeSummary> Cache;         //  

  if (Cache.Load(inFileName)) //   .
  {
    MqlParam Params[][5];
    const int Size = Cache.GetInputs(inNum, Params); //     .

    Print(Cache.Header.ToString()); //     .
    Print(Cache[inNum].ToString()); //  .   
    ArrayPrint(Params);             //     .

//    Cache.SaveSet(inNum); //  set-  .
//    Cache.Save(__FILE__); //   opt-.

//    Print(Cache[GetMaxProfitPos(Cache)].ToString()); //  .     .
  }
}